Index: documentViewer.py
===================================================================
--- documentViewer.py	(revision 452)
+++ documentViewer.py	(revision 498)
@@ -1,55 +1,32 @@
-
 from OFS.Folder import Folder
 from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate
-from Products.PageTemplates.PageTemplateFile import PageTemplateFile 
+from Products.PageTemplates.PageTemplateFile import PageTemplateFile
+from App.ImageFile import ImageFile
 from AccessControl import ClassSecurityInfo
 from AccessControl import getSecurityManager
 from Globals import package_home
-from Products.zogiLib.zogiLib import browserCheck
-
-from Ft.Xml import EMPTY_NAMESPACE, Parse 
-import Ft.Xml.Domlette
-import os.path
+
+import xml.etree.ElementTree as ET
+
+import os
 import sys
 import urllib
-import urllib2
 import logging
 import math
 import urlparse 
-import cStringIO
 import re
 import string
 
-def logger(txt,method,txt2):
-    """logging"""
-    logging.info(txt+ txt2)
-    
-    
-def getInt(number, default=0):
-    """returns always an int (0 in case of problems)"""
-    try:
-        return int(number)
-    except:
-        return int(default)
-
-def getTextFromNode(nodename):
-    """get the cdata content of a node"""
-    if nodename is None:
-        return ""
-    nodelist=nodename.childNodes
-    rc = ""
-    for node in nodelist:
-        if node.nodeType == node.TEXT_NODE:
-           rc = rc + node.data
-    return rc
-
+from SrvTxtUtils import getInt, getText, getHttpData, refreshingImageFileIndexHtml
+    
 def serializeNode(node, encoding="utf-8"):
     """returns a string containing node as XML"""
-    stream = cStringIO.StringIO()
-    #logging.debug("BUF: %s"%(stream))
-    Ft.Xml.Domlette.Print(node, stream=stream, encoding=encoding)
-    s = stream.getvalue()
-    #logging.debug("BUF: %s"%(s))
-    stream.close()
+    s = ET.tostring(node)
+    
+    # 4Suite:
+    #    stream = cStringIO.StringIO()
+    #    Ft.Xml.Domlette.Print(node, stream=stream, encoding=encoding)
+    #    s = stream.getvalue()
+    #    stream.close()
     return s
 
@@ -115,52 +92,10 @@
     return bt
 
-       
-def getParentDir(path):
-    """returns pathname shortened by one"""
-    return '/'.join(path.split('/')[0:-1])
-        
-
-def getHttpData(url, data=None, num_tries=3, timeout=10):
-    """returns result from url+data HTTP request"""
-    # we do GET (by appending data to url)
-    if isinstance(data, str) or isinstance(data, unicode):
-        # if data is string then append
-        url = "%s?%s"%(url,data)
-    elif isinstance(data, dict) or isinstance(data, list) or isinstance(data, tuple):
-        # urlencode
-        url = "%s?%s"%(url,urllib.urlencode(data))
-    
-    response = None
-    errmsg = None
-    for cnt in range(num_tries):
-        try:
-            logging.debug("getHttpData(#%s %ss) url=%s"%(cnt+1,timeout,url))
-            if sys.version_info < (2, 6):
-                # set timeout on socket -- ugly :-(
-                import socket
-                socket.setdefaulttimeout(float(timeout))
-                response = urllib2.urlopen(url)
-            else:
-                response = urllib2.urlopen(url,timeout=float(timeout))
-            # check result?
-            break
-        except urllib2.HTTPError, e:
-            logging.error("getHttpData: HTTP error(%s): %s"%(e.code,e))
-            errmsg = str(e)
-            # stop trying
-            break
-        except urllib2.URLError, e:
-            logging.error("getHttpData: URLLIB error(%s): %s"%(e.reason,e))
-            errmsg = str(e)
-            # stop trying
-            #break
-
-    if response is not None:
-        data = response.read()
-        response.close()
-        return data
-    
-    raise IOError("ERROR fetching HTTP data from %s: %s"%(url,errmsg))
-    #return None
+def getParentPath(path, cnt=1):
+    """returns pathname shortened by cnt"""
+    # make sure path doesn't end with /
+    path = path.rstrip('/')
+    # split by /, shorten, and reassemble
+    return '/'.join(path.split('/')[0:-cnt])
 
 ##
@@ -175,10 +110,16 @@
         {'label':'main config','action':'changeDocumentViewerForm'},
         )
+    
+    metadataService = None
+    """MetaDataFolder instance"""
 
     # templates and forms
+    viewer_text = PageTemplateFile('zpt/viewer_text', globals())
+    viewer_images = PageTemplateFile('zpt/viewer_images', globals())
     viewer_main = PageTemplateFile('zpt/viewer_main', globals())
     toc_thumbs = PageTemplateFile('zpt/toc_thumbs', globals())
     toc_text = PageTemplateFile('zpt/toc_text', globals())
     toc_figures = PageTemplateFile('zpt/toc_figures', globals())
+    toc_none = PageTemplateFile('zpt/toc_none', globals())
     page_main_images = PageTemplateFile('zpt/page_main_images', globals())
     page_main_double = PageTemplateFile('zpt/page_main_double', globals())
@@ -189,11 +130,11 @@
     page_main_pureXml = PageTemplateFile('zpt/page_main_pureXml', globals())
     head_main = PageTemplateFile('zpt/head_main', globals())
-    docuviewer_css = PageTemplateFile('css/docuviewer.css', globals())
     info_xml = PageTemplateFile('zpt/info_xml', globals())
+    docuviewer_css = ImageFile('css/docuviewer.css',globals())
+    # make ImageFile better for development
+    docuviewer_css.index_html = refreshingImageFileIndexHtml
     
     
     thumbs_main_rss = PageTemplateFile('zpt/thumbs_main_rss', globals())
-    security.declareProtected('View management screens','changeDocumentViewerForm')    
-    changeDocumentViewerForm = PageTemplateFile('zpt/changeDocumentViewer', globals())
 
     
@@ -209,63 +150,73 @@
         
         templateFolder = Folder('template')
-        #self['template'] = templateFolder # Zope-2.12 style
-        self._setObject('template',templateFolder) # old style
+        self['template'] = templateFolder # Zope-2.12 style
+        #self._setObject('template',templateFolder) # old style
         try:
             import MpdlXmlTextServer
             textServer = MpdlXmlTextServer.MpdlXmlTextServer(id='fulltextclient',serverName=textServerName)
-            #templateFolder['fulltextclient'] = xmlRpcClient
-            templateFolder._setObject('fulltextclient',textServer)
+            templateFolder['fulltextclient'] = textServer
+            #templateFolder._setObject('fulltextclient',textServer)
         except Exception, e:
             logging.error("Unable to create MpdlXmlTextServer for fulltextclient: "+str(e))
+            
         try:
             from Products.zogiLib.zogiLib import zogiLib
             zogilib = zogiLib(id="zogilib", title="zogilib for docuviewer", dlServerURL=imageScalerUrl, layout="book")
-            #templateFolder['zogilib'] = zogilib
-            templateFolder._setObject('zogilib',zogilib)
+            templateFolder['zogilib'] = zogilib
+            #templateFolder._setObject('zogilib',zogilib)
         except Exception, e:
             logging.error("Unable to create zogiLib for zogilib: "+str(e))
-        
+            
+        try:
+            # assume MetaDataFolder instance is called metadata 
+            self.metadataService = getattr(self, 'metadata')
+        except Exception, e:
+            logging.error("Unable to find MetaDataFolder 'metadata': "+str(e))
+            
+        if digilibBaseUrl is not None:
+            self.digilibBaseUrl = digilibBaseUrl
+            
         
     # proxy text server methods to fulltextclient
     def getTextPage(self, **args):
-        """get page"""
+        """returns full text content of page"""
         return self.template.fulltextclient.getTextPage(**args)
 
-    def getOrigPages(self, **args):
-        """get page"""
-        return self.template.fulltextclient.getOrigPages(**args)
-    
-    def getOrigPagesNorm(self, **args):
-        """get page"""
-        return self.template.fulltextclient.getOrigPagesNorm(**args)
-
+    #WTF?
     def getQuery(self, **args):
         """get query in search"""
         return self.template.fulltextclient.getQuery(**args)
      
+    #WTF?
     def getSearch(self, **args):
         """get search"""
         return self.template.fulltextclient.getSearch(**args)
     
+    #WTF?
     def getGisPlaces(self, **args):
         """get gis places"""
         return self.template.fulltextclient.getGisPlaces(**args)
  
+    #WTF?
     def getAllGisPlaces(self, **args):
         """get all gis places """
         return self.template.fulltextclient.getAllGisPlaces(**args)
        
-    def getTranslate(self, **args):
+    #WTF?
+    def getWordInfo(self, **args):
         """get translate"""
-        return self.template.fulltextclient.getTranslate(**args)
-
+        return self.template.fulltextclient.getWordInfo(**args)
+
+    #WTF?
     def getLemma(self, **args):
         """get lemma"""
         return self.template.fulltextclient.getLemma(**args)
 
+    #WTF?
     def getLemmaQuery(self, **args):
         """get query"""
         return self.template.fulltextclient.getLemmaQuery(**args)
 
+    #WTF?
     def getLex(self, **args):
         """get lex"""
@@ -273,9 +224,9 @@
 
     def getToc(self, **args):
-        """get toc"""
+        """returns the full table of contents (in internal format)"""
         return self.template.fulltextclient.getToc(**args)
 
     def getTocPage(self, **args):
-        """get tocpage"""
+        """returns one page of the table of contents"""
         return self.template.fulltextclient.getTocPage(**args)
 
@@ -291,5 +242,5 @@
         '''
         logging.debug("HHHHHHHHHHHHHH:load the rss")
-        logger("documentViewer (index)", logging.INFO, "mode: %s url:%s start:%s pn:%s"%(mode,url,start,pn))
+        logging.debug("documentViewer (index) mode: %s url:%s start:%s pn:%s"%(mode,url,start,pn))
         
         if not hasattr(self, 'template'):
@@ -313,18 +264,18 @@
                
         return pt(docinfo=docinfo,pageinfo=pageinfo,viewMode=viewMode)
+
   
     security.declareProtected('View','index_html')
-    def index_html(self,url,mode="texttool",viewMode="auto",tocMode="thumbs",start=None,pn=1,mk=None):
-        '''
-        view it
+    def index_html(self,url,mode="texttool",viewMode="auto",viewType=None,tocMode="thumbs",start=1,pn=1):
+        """
+        view page
+        @param url: url which contains display information
         @param mode: defines how to access the document behind url 
-        @param url: url which contains display information
-        @param viewMode: if images display images, if text display text, default is auto (text,images or auto)
+        @param viewMode: 'images': display images, 'text': display text, default is 'auto'
+        @param viewType: sub-type of viewMode, e.g. 'dict' for viewMode='text'
         @param tocMode: type of 'table of contents' for navigation (thumbs, text, figures, none)
-        @param characterNormalization type of text display (reg, norm, none)
-        @param querySearch: type of different search modes (fulltext, fulltextMorph, xpath, xquery, ftIndex, ftIndexMorph, fulltextMorphLemma)
-        '''
-        
-        logging.debug("documentViewer (index) mode: %s url:%s start:%s pn:%s"%(mode,url,start,pn))
+        """
+        
+        logging.debug("documentViewer(index_html) mode=%s url=%s viewMode=%s viewType=%s start=%s pn=%s"%(mode,url,viewMode,viewType,start,pn))
         
         if not hasattr(self, 'template'):
@@ -341,19 +292,34 @@
             # get table of contents
             docinfo = self.getToc(mode=tocMode, docinfo=docinfo)
-            
-        if viewMode=="auto": # automodus gewaehlt
-            if docinfo.has_key('textURL') or docinfo.get('textURLPath',None): #texturl gesetzt und textViewer konfiguriert
-                viewMode="text_dict"
+
+        # auto viewMode: text if there is a text else images
+        if viewMode=="auto": 
+            if docinfo.get('textURL', None) or docinfo.get('textURLPath', None): 
+                viewMode = "text"
+                viewType = "dict"
             else:
-                viewMode="images"
+                viewMode = "images"
                 
-        pageinfo = self.getPageinfo(start=start,current=pn, docinfo=docinfo,viewMode=viewMode,tocMode=tocMode)
-        
-        if (docinfo.get('textURLPath',None)):
-            page = self.getTextPage(docinfo=docinfo, pageinfo=pageinfo)
-            pageinfo['textPage'] = page
-        tt = getattr(self, 'template')   
-        pt = getattr(tt, 'viewer_main')               
-        return pt(docinfo=docinfo,pageinfo=pageinfo,viewMode=viewMode,mk=self.generateMarks(mk))
+        elif viewMode == "text_dict":
+            # legacy fix
+            viewMode = "text"
+            viewType = "dict"
+            
+        # stringify viewType
+        if isinstance(viewType, list):
+            logging.debug("index_html: viewType is list:%s"%viewType)
+            viewType = ','.join([t for t in viewType if t])
+                        
+        pageinfo = self.getPageinfo(start=start, current=pn, docinfo=docinfo, viewMode=viewMode, viewType=viewType, tocMode=tocMode)
+                    
+        # get template /template/viewer_$viewMode
+        pt = getattr(self.template, 'viewer_%s'%viewMode, None)
+        if pt is None:
+            logging.error("No template for viewMode=%s!"%viewMode)
+            # TODO: error page?
+            return "No template for viewMode=%s!"%viewMode
+        
+        # and execute with parameters
+        return pt(docinfo=docinfo, pageinfo=pageinfo)
   
     def generateMarks(self,mk):
@@ -378,4 +344,23 @@
         url = self.template.zogilib.getDLBaseUrl()
         return url
+    
+    def getScalerUrl(self, fn=None, pn=None, dw=100, dh=100, docinfo=None):
+        """returns URL to digilib Scaler with params"""
+        url = None
+        if docinfo is not None:
+            url = docinfo.get('imageURL', None)
+            
+        if url is None:
+            url = "%s/servlet/Scaler?"%self.digilibBaseUrl
+            if fn is None and docinfo is not None:
+                fn = docinfo.get('imagePath','')
+            
+            url += "fn=%s"%fn
+            
+        if pn:
+            url += "&pn=%s"%pn
+            
+        url += "&dw=%s&dh=%s"%(dw,dh)
+        return url
 
     def getDocumentViewerURL(self):
@@ -384,5 +369,5 @@
     
     def getStyle(self, idx, selected, style=""):
-        """returns a string with the given style and append 'sel' if path == selected."""
+        """returns a string with the given style and append 'sel' if idx == selected."""
         #logger("documentViewer (getstyle)", logging.INFO, "idx: %s selected: %s style: %s"%(idx,selected,style))
         if idx == selected:
@@ -391,50 +376,61 @@
             return style
     
-    def getLink(self, param=None, val=None, params=None, baseUrl=None, paramSep='&'):
-        """returns URL to documentviewer with parameter param set to val or from dict params"""
+    def getParams(self, param=None, val=None, params=None, duplicates=None):
+        """returns dict with URL parameters.
+        
+        Takes URL parameters and additionally param=val or dict params.
+        Deletes key if value is None."""
         # copy existing request params
-        urlParams=self.REQUEST.form.copy()
+        newParams=self.REQUEST.form.copy()
         # change single param
         if param is not None:
             if val is None:
-                if urlParams.has_key(param):
-                    del urlParams[param]
+                if newParams.has_key(param):
+                    del newParams[param]
             else:
-                urlParams[param] = str(val)
+                newParams[param] = str(val)
                 
         # change more params
         if params is not None:
-            for k in params.keys():
-                v = params[k]
+            for (k, v) in params.items():
                 if v is None:
                     # val=None removes param
-                    if urlParams.has_key(k):
-                        del urlParams[k]
+                    if newParams.has_key(k):
+                        del newParams[k]
                         
                 else:
-                    urlParams[k] = v
-
-        # FIXME: does this belong here?
-        if urlParams.get("mode", None) == "filepath": #wenn beim erst Aufruf filepath gesetzt wurde aendere das nun zu imagepath
-                urlParams["mode"] = "imagepath"
-                urlParams["url"] = getParentDir(urlParams["url"])
-                
+                    newParams[k] = v
+
+        if duplicates:
+            # eliminate lists (coming from duplicate keys)
+            for (k,v) in newParams.items():
+                if isinstance(v, list):
+                    if duplicates == 'comma':
+                        # make comma-separated list of non-empty entries
+                        newParams[k] = ','.join([t for t in v if t])
+                    elif duplicates == 'first':
+                        # take first non-empty entry
+                        newParams[k] = [t for t in v if t][0]
+        
+        return newParams
+    
+    def getLink(self, param=None, val=None, params=None, baseUrl=None, paramSep='&', duplicates='comma'):
+        """returns URL to documentviewer with parameter param set to val or from dict params"""
+        urlParams = self.getParams(param=param, val=val, params=params, duplicates=duplicates)
         # quote values and assemble into query string (not escaping '/')
-        ps = paramSep.join(["%s=%s"%(k,urllib.quote_plus(v,'/')) for (k, v) in urlParams.items()])
-        #ps = urllib.urlencode(urlParams)
+        ps = paramSep.join(["%s=%s"%(k,urllib.quote_plus(unicode(v),'/')) for (k, v) in urlParams.items()])
         if baseUrl is None:
-            baseUrl = self.REQUEST['URL1']
+            baseUrl = self.getDocumentViewerURL()
             
         url = "%s?%s"%(baseUrl, ps)
         return url
 
-
-    def getLinkAmp(self, param=None, val=None, params=None, baseUrl=None):
+    def getLinkAmp(self, param=None, val=None, params=None, baseUrl=None, duplicates='comma'):
         """link to documentviewer with parameter param set to val"""
-        return self.getLink(param, val, params, baseUrl, '&amp;')
+        return self.getLink(param=param, val=val, params=params, baseUrl=baseUrl, paramSep='&amp;', duplicates=duplicates)
+    
     
     def getInfo_xml(self,url,mode):
         """returns info about the document as XML"""
-
         if not self.digilibBaseUrl:
             self.digilibBaseUrl = self.findDigilibUrl() or "http://nausikaa.mpiwg-berlin.mpg.de/digitallibrary"
@@ -444,26 +440,12 @@
         return pt(docinfo=docinfo)
 
-    def getOptionToggle(self, newState=None, optionName='text_options_open', initialState=True):
-        """returns new option state"""
-        if not self.REQUEST.SESSION.has_key(optionName):
-            # not in session -- initial
-            opt = {'lastState': newState, 'state': initialState}
-        else:
-            opt = self.REQUEST.SESSION.get(optionName)
-            if opt['lastState'] != newState:
-                # state in session has changed -- toggle
-                opt['state'] = not opt['state']
-                opt['lastState'] = newState
-        
-        self.REQUEST.SESSION[optionName] = opt
-        return opt['state']
-    
     def isAccessible(self, docinfo):
         """returns if access to the resource is granted"""
         access = docinfo.get('accessType', None)
         logging.debug("documentViewer (accessOK) access type %s"%access)
-        if access is not None and access == 'free':
+        if access == 'free':
             logging.debug("documentViewer (accessOK) access is free")
             return True
+        
         elif access is None or access in self.authgroups:
             # only local access -- only logged in users
@@ -479,77 +461,232 @@
         return False
     
+
+
+    def getDocinfo(self, mode, url):
+        """returns docinfo depending on mode"""
+        logging.debug("getDocinfo: mode=%s, url=%s"%(mode,url))
+        # look for cached docinfo in session
+        if self.REQUEST.SESSION.has_key('docinfo'):
+            docinfo = self.REQUEST.SESSION['docinfo']
+            # check if its still current
+            if docinfo is not None and docinfo.get('mode', None) == mode and docinfo.get('url', None) == url:
+                logging.debug("getDocinfo: docinfo in session. keys=%s"%docinfo.keys())
+                return docinfo
+            
+        # new docinfo
+        docinfo = {'mode': mode, 'url': url}
+        # add self url
+        docinfo['viewerUrl'] = self.getDocumentViewerURL()
+        docinfo['digilibBaseUrl'] = self.digilibBaseUrl
+        # get index.meta DOM
+        docUrl = None
+        metaDom = None
+        if mode=="texttool": 
+            # url points to document dir or index.meta
+            metaDom = self.metadataService.getDomFromPathOrUrl(url)
+            docUrl = url.replace('/index.meta', '')
+            if metaDom is None:
+                raise IOError("Unable to find index.meta for mode=texttool!")
+
+        elif mode=="imagepath":
+            # url points to folder with images, index.meta optional
+            # asssume index.meta in parent dir
+            docUrl = getParentPath(url)
+            metaDom = self.metadataService.getDomFromPathOrUrl(docUrl)
+
+        elif mode=="filepath":
+            # url points to image file, index.meta optional
+            # asssume index.meta is two path segments up
+            docUrl = getParentPath(url, 2)
+            metaDom = self.metadataService.getDomFromPathOrUrl(docUrl)
+
+        else:
+            logging.error("documentViewer (getdocinfo) unknown mode: %s!"%mode)
+            raise ValueError("Unknown mode %s! Has to be one of 'texttool','imagepath','filepath'."%(mode))
+        
+        docinfo['documentUrl'] = docUrl
+        # process index.meta contents
+        if metaDom is not None and metaDom.tag == 'resource':
+            # document directory name and path
+            resource = self.metadataService.getResourceData(dom=metaDom)
+            if resource:
+                docinfo = self.getDocinfoFromResource(docinfo, resource)
+
+            # texttool info
+            texttool = self.metadataService.getTexttoolData(dom=metaDom)
+            if texttool:
+                docinfo = self.getDocinfoFromTexttool(docinfo, texttool)
+            
+            # bib info
+            bib = self.metadataService.getBibData(dom=metaDom)
+            if bib:
+                docinfo = self.getDocinfoFromBib(docinfo, bib)
+            else:
+                # no bib - try info.xml
+                docinfo = self.getDocinfoFromPresentationInfoXml(docinfo)
                 
-    def getDirinfoFromDigilib(self,path,docinfo=None,cut=0):
-        """gibt param von dlInfo aus"""
-        if docinfo is None:
-            docinfo = {}
-        
-        for x in range(cut):
-               
-                path=getParentDir(path)
-       
+            # auth info
+            access = self.metadataService.getAccessData(dom=metaDom)
+            if access:
+                docinfo = self.getDocinfoFromAccess(docinfo, access)
+
+            # attribution info
+            attribution = self.metadataService.getAttributionData(dom=metaDom)
+            if attribution:
+                logging.debug("getDocinfo: attribution=%s"%repr(attribution))
+                docinfo['attribution'] = attribution
+                #docinfo = self.getDocinfoFromAccess(docinfo, access)
+
+            # copyright info
+            copyright = self.metadataService.getCopyrightData(dom=metaDom)
+            if copyright:
+                logging.debug("getDocinfo: copyright=%s"%repr(copyright))
+                docinfo['copyright'] = copyright
+                #docinfo = self.getDocinfoFromAccess(docinfo, access)
+
+        # image path
+        if mode != 'texttool':
+            # override image path from texttool with url
+            docinfo['imagePath'] = url.replace('/mpiwg/online/', '', 1)
+
+        # number of images from digilib
+        if docinfo.get('imagePath', None):
+            docinfo['imageURL'] = self.digilibBaseUrl + "/servlet/Scaler?fn=" + docinfo['imagePath']
+            docinfo = self.getDocinfoFromDigilib(docinfo, docinfo['imagePath'])
+
+        logging.debug("documentViewer (getdocinfo) docinfo: keys=%s"%docinfo.keys())
+        #logging.debug("documentViewer (getdocinfo) docinfo: %s"%docinfo)
+        # store in session
+        self.REQUEST.SESSION['docinfo'] = docinfo
+        return docinfo
+
+    def getDocinfoFromResource(self, docinfo, resource):
+        """reads contents of resource element into docinfo"""
+        docName = resource.get('name', None)
+        docinfo['documentName'] = docName
+        docPath = resource.get('archive-path', None)
+        if docPath:
+            # clean up document path
+            if docPath[0] != '/':
+                docPath = '/' + docPath
+                
+            if docName and (not docPath.endswith(docName)):
+                docPath += "/" + docName
+            
+        else:
+            # use docUrl as docPath
+            docUrl = docinfo['documentURL']
+            if not docUrl.startswith('http:'):
+                docPath = docUrl
+        if docPath:
+            # fix URLs starting with /mpiwg/online
+            docPath = docPath.replace('/mpiwg/online', '', 1)
+
+        docinfo['documentPath'] = docPath
+        return docinfo
+
+    def getDocinfoFromTexttool(self, docinfo, texttool):
+        """reads contents of texttool element into docinfo"""
+        # image dir
+        imageDir = texttool.get('image', None)
+        docPath = docinfo.get('documentPath', None)
+        if imageDir and docPath:
+            #print "image: ", imageDir, " archivepath: ", archivePath
+            imageDir = os.path.join(docPath, imageDir)
+            imageDir = imageDir.replace('/mpiwg/online', '', 1)
+            docinfo['imagePath'] = imageDir
+        
+        # old style text URL
+        textUrl = texttool.get('text', None)
+        if textUrl and docPath:
+            if urlparse.urlparse(textUrl)[0] == "": #keine url
+                textUrl = os.path.join(docPath, textUrl) 
+            
+            docinfo['textURL'] = textUrl
+    
+        # new style text-url-path
+        textUrl = texttool.get('text-url-path', None)
+        if textUrl:
+            docinfo['textURLPath'] = textUrl
+            
+        # page flow
+        docinfo['pageFlow'] = texttool.get('page-flow', 'ltr')
+            
+        # odd pages are left
+        docinfo['oddPage'] = texttool.get('odd-scan-position', 'left')
+            
+        # number of title page (0: not defined)
+        docinfo['titlePage'] = texttool.get('title-scan-no', 0)
+            
+        # old presentation stuff
+        presentation = texttool.get('presentation', None)
+        if presentation and docPath:
+            if presentation.startswith('http:'):
+                docinfo['presentationUrl'] = presentation
+            else:
+                docinfo['presentationUrl'] = os.path.join(docPath, presentation)
+            
+        
+        return docinfo
+
+    def getDocinfoFromBib(self, docinfo, bib):
+        """reads contents of bib element into docinfo"""
+        logging.debug("getDocinfoFromBib bib=%s"%repr(bib))
+        # put all raw bib fields in dict "bib"
+        docinfo['bib'] = bib
+        bibtype = bib.get('@type', None)
+        docinfo['bibType'] = bibtype
+        # also store DC metadata for convenience
+        dc = self.metadataService.getDCMappedData(bib)
+        docinfo['creator'] = dc.get('creator',None)
+        docinfo['title'] = dc.get('title',None)
+        docinfo['date'] = dc.get('date',None)
+        return docinfo
+            
+    def getDocinfoFromAccess(self, docinfo, acc):
+        """reads contents of access element into docinfo"""
+        #TODO: also read resource type
+        logging.debug("getDocinfoFromAccess acc=%s"%repr(acc))
+        try:
+            acctype = acc['@attr']['type']
+            if acctype:
+                access=acctype
+                if access in ['group', 'institution']:
+                    access = acc['name'].lower()
+                
+                docinfo['accessType'] = access
+
+        except:
+            pass
+        
+        return docinfo
+
+    def getDocinfoFromDigilib(self, docinfo, path):
         infoUrl=self.digilibBaseUrl+"/dirInfo-xml.jsp?mo=dir&fn="+path
-    
-        logging.debug("documentViewer (getparamfromdigilib) dirInfo from %s"%(infoUrl))
-        
+        # fetch data
         txt = getHttpData(infoUrl)
-        if txt is None:
-            raise IOError("Unable to get dir-info from %s"%(infoUrl))
-
-        dom = Parse(txt)
-        sizes=dom.xpath("//dir/size")
-        logging.debug("documentViewer (getparamfromdigilib) dirInfo:size"%sizes)
-        
-        if sizes:
-            docinfo['numPages'] = int(getTextFromNode(sizes[0]))
+        if not txt:
+            logging.error("Unable to get dir-info from %s"%(infoUrl))
+            return docinfo
+
+        dom = ET.fromstring(txt)
+        size = getText(dom.find("size"))
+        logging.debug("getDocinfoFromDigilib: size=%s"%size)
+        if size:
+            docinfo['numPages'] = int(size)
         else:
             docinfo['numPages'] = 0
             
         # TODO: produce and keep list of image names and numbers
-                        
         return docinfo
-    
-    def getIndexMetaPath(self,url):
-        """gib nur den Pfad zurueck"""
-        regexp = re.compile(r".*(experimental|permanent)/(.*)")
-        regpath = regexp.match(url)
-        if (regpath==None):
-            return ""
-        logging.debug("(getDomFromIndexMeta): URLXAXA: %s"%regpath.group(2))            
-        return ("/mpiwg/online/"+regpath.group(1)+"/"+regpath.group(2))
-     
-    
-    
-    def getIndexMetaUrl(self,url):
-        """returns utr  of index.meta document at url"""
-      
-        metaUrl = None
-        if url.startswith("http://"):
-            # real URL
-            metaUrl = url
-        else:
-            # online path
-            server=self.digilibBaseUrl+"/servlet/Texter?fn="
-            metaUrl=server+url.replace("/mpiwg/online","")
-            if not metaUrl.endswith("index.meta"):
-                metaUrl += "/index.meta"
-        
-        return metaUrl
-    
-    def getDomFromIndexMeta(self, url):
-        """get dom from index meta"""
-        dom = None
-        metaUrl = self.getIndexMetaUrl(url)
-                
-        logging.debug("(getDomFromIndexMeta): METAURL: %s"%metaUrl)
-        txt=getHttpData(metaUrl)
-        if txt is None:
-            raise IOError("Unable to read index meta from %s"%(url))
-        
-        dom = Parse(txt)
-        return dom
-    
-    def getPresentationInfoXML(self, url):
-        """returns dom of info.xml document at url"""
+            
+            
+    def getDocinfoFromPresentationInfoXml(self,docinfo):
+        """gets DC-like bibliographical information from the presentation entry in texttools"""
+        url = docinfo.get('presentationUrl', None)
+        if not url:
+            logging.error("getDocinfoFromPresentation: no URL!")
+            return docinfo
+        
         dom = None
         metaUrl = None
